unit vocplay;

interface uses crt,dos;

TYPE vocheader = record
       Ident : array[0..19] of char;
       Sampoff : word;
       Verslo  : Byte;
       Vershi  : Byte;
       Ident_code : word;
     end;

     Voiceblock = record
       Ident_code  : byte;
       Long_lo : word;
       Long_hi : byte;
       SR       : byte;
       Pack     : byte;
     end;

const
  { Soundblaster - Constantes }
  Startport          : word = $200;
  Endport            : word = $280;
  force_irq          : boolean = false;
  force_dma          : boolean = false;
  force_base         : boolean = false;
  dsp_irq            : byte = $5;        { Interruption de la SB,}
                                        {modification de la valeur}
                                        { par la routine INIT    }
  dma_ch             : byte = 1;         { Canal DMA, standard  }
                                        { = 1, sur SB 16 ASP ; autres}
                                        { valeurs ncessaires ...     }
  dsp_adr            : word = $220;      { Adresse de base  des DSP.   }
                                        { La routine init  }
                                        { change la valeur   }
  SbVersMin          : BYTE = 0;         { Identification de la version }
  SbVersMaj          : BYTE = 0;
  STEREO             : BOOLEAN = false;  { En Stereo ?     }
  SbRegDetected      : BOOLEAN = FALSE;  { SB normale installe ?     }
  IRQDetected        : BOOLEAN = FALSE;
  SbRegInited        : BOOLEAN = FALSE;
  SbProDetected      : BOOLEAN = FALSE;  { SB Pro installe ?         }
  SbProInited        : BOOLEAN = FALSE;
  Sb16Detected       : BOOLEAN = FALSE;  { SB 16 ASP installe ?      }
  Sb16Inited         : BOOLEAN = FALSE;
  MixerDetected      : BOOLEAN = FALSE;  { Sinon, utilisez la carte >= SB Pro   }

  { Voc - Constantes }
  bloc_actif        : byte = 1;


  { Soundblaster - Variables }
var dsp_rdy_voc      : boolean;
    T_Bloc           : word;
    Transfer_Testing : boolean;
    SaveExitProc     : Pointer;             { Ncessaire, Exitproc intgr  }

var lastone          : boolean;
    VOC_READY        : boolean;
    inread           : array[1..25] of byte;
    vocsstereo       : boolean;
    vocf             : file;
    fgr              : longint;
    blk1,blk2        : pointer;
    voch             : vocheader;
    vblock           : voiceblock;


procedure voc_done;

procedure Init_Voc(filename : string);

FUNCTION Detect_Mixer_sb16 : BOOLEAN;

procedure Jouer_Block_Dsp(gr : word;bk : pointer;b1,b2 : boolean);

procedure write_sbConfig;

function Init_SB : boolean;

implementation

TYPE
  pt = record                           { permet, d'une faon trs simple, }
    ofs,sgm  :  word;                   { la prise en charge de pointeurs  }
  end;

CONST
  filter_activ       : boolean = false;
  balance            : byte = 12;
  Mastervolume       : byte = 29;
  Samfreq            : word = 22;
  PC    = 0;
  AMIGA = 1;
  interrupt_trouve : boolean = false;
  interrupt_check    : boolean = false;
  timer_per_second   : word = 1000;      { Nombre d'interrupts par sc. }
  Sampling_frequence  : word = 10000;     { Valeur par df.: La frquence de : Sampling}
  dma_page           : array[0..3] of byte = ($87,$83,$81,$81);
  dma_adr            : array[0..3] of byte = (0,2,4,6);
  dma_wc             : array[0..3] of byte = (1,3,5,7);

  sb16_outputLong  : word = 0;
  Dern_sortie     : boolean = false;

VAR
 TailleBloc        : word;            { Taille des Sound-Puffers    }
 dsp_rdy_sb16        : boolean;         { Flag pour terminer la trans-}
                                        { mission de donnes via DMA  }
 SbVersStr           : string[5];       { la version-SB comme String  }
 oldInt              : pointer;         { pour une sauvegarde de      }
                                        { l'interrupt dont  besoin le}
                                        { SB pour le transfert de la DMA}
 irqmsk              : byte;            { prise en charge d'Interrupt }
 blk                 : pointer;         { Pointeur sur le tampon de donnes }
 Sampling_Rate       : byte;            { la valeur de la frquence }
                                        { passe  la DSP         }
 intback             : pointer;
 port21              : byte;


{
***********************************************************************
                        PROCEDURES - SOUND BLASTER
***********************************************************************
}

procedure Wr_dsp(v : byte);
{
 Attend jusqu' ce que la DSP soit prte  l'criture, et crit alors
 dans la DSP l'octet transmis dans "v"
}
begin;
  while port[dsp_adr+$c] >= 128 do ;
  port[dsp_adr+$c] := v;
end;

FUNCTION SbReadByte : BYTE;
{
 La fonction attend, jusqu' ce que la DSP puisse tre lue et
 retourne alors la valeur lue.
}
begin;
  while port[dsp_adr+$a] = $AA do ;     { attend que DSP soit prte }
  SbReadByte := port[dsp_adr+$a];       { lit une valeur }
end;

procedure SBreset;
VAR bt,ct, stat : BYTE;
begin;
  PORT[dsp_adr+$6] := 1;                { dsp_adr+$6 = Resettfunktion}
  FOR ct := 1 TO 100 DO;
  PORT[dsp_adr+$6] := 0;
  bt := 0;
  repeat
    ct := 0;
    repeat
      stat := port[dsp_adr + $E];
    until (ct > 8000) or (stat >= 128);
    inc(bt);
  until (bt > 100) or (port[dsp_adr + $A] = $AA);
end;



FUNCTION Reset_SBCard : BOOLEAN;
{
 La fonction effectue un reset du DSP. Si le reset russit,
 elle retourne TRUE, sinon FALSE
}
CONST  ready = $AA;
VAR ct, stat : BYTE;
BEGIN
  PORT[dsp_adr+$6] := 1;                { dsp_adr+$6 = fonction de reset }
  FOR ct := 1 TO 100 DO;
  PORT[dsp_adr+$6] := 0;
  stat := 0;
  ct   := 0;                            { Comparaison  ct < 100, car }
  WHILE (stat <> ready)                 { l'initialisation dure    }
  AND   (ct < 100)      DO BEGIN        { environ 100ms             }
    stat := PORT[dsp_adr+$E];
    stat := PORT[dsp_adr+$a];
    INC(ct);
  END;
  Reset_SBCard := (stat = ready);
END;


FUNCTION Detect_SBReg : BOOLEAN;
{
 La fonction retourne TRUE, quand une carte Soundblaster a pu  tre
 initialise, sinon FALSE. La variable dsp_adr reoit
 l'adresse de base de la SB.
}
VAR
  Port, Lst : WORD;
BEGIN
 Detect_SBReg := SbRegDetected;
 IF SbRegDetected THEN EXIT;            { Exit, lorsque l'initialisation est faite }
 Port := Startport;                     { Adresse SB possibles }
 Lst  := Endport;                       { entre $210 et $280 !      }
 WHILE (NOT SbRegDetected)
 AND   (Port <= Lst)  DO BEGIN
   dsp_adr := Port;
   SbRegDetected := Reset_SBCard;
   IF NOT SbRegDetected THEN
     INC(Port, $10);
 END;
 Detect_SBReg := SbRegDetected;
END;

PROCEDURE SbGetDSPVersion;
{
 Fournit le numro de version de la DSP et le dpose dans les variables
 globales SBVERSMAJ et SBVERSMIN, ainsi que SBVERSSTR.
}
VAR i : WORD;
    t : WORD;
    s : STRING[2];
BEGIN
  Wr_dsp($E1);                     { $E1 = interroge le numro de version }
  SbVersMaj := SbReadByte;
  SbVersMin := SbReadByte;
  str(SbVersMaj, SbVersStr);
  SbVersStr := SbVersStr + '.';
  str(SbVersMin, s);
  if SbVersMin > 9 then
    SbVersStr := SbVersStr +       s
  else
    SbVersStr := SbVersStr + '0' + s;
END;

function wrt_dsp_adr_sb16 : string;
{
 Renvoie l'adresse de Base comme String
}
begin;
  case dsp_adr of
    $210 : wrt_dsp_adr_sb16 := '210';
    $220 : wrt_dsp_adr_sb16 := '220';
    $230 : wrt_dsp_adr_sb16 := '230';
    $240 : wrt_dsp_adr_sb16 := '240';
    $250 : wrt_dsp_adr_sb16 := '250';
    $260 : wrt_dsp_adr_sb16 := '260';
    $270 : wrt_dsp_adr_sb16 := '270';
    $270 : wrt_dsp_adr_sb16 := '280';
   END;
end;

function wrt_dsp_irq : string;
{
 Renvoie l'IRQ de la SB comme String
}
begin;
  case dsp_irq of
     $2 : wrt_dsp_irq := '2 h';
     $3 : wrt_dsp_irq := '3 h';
     $5 : wrt_dsp_irq := '5 h';
     $7 : wrt_dsp_irq := '7 h';
    $10 : wrt_dsp_irq := '10 h';
   END;
end;

procedure Set_Timeconst_sb16(tc : byte);
{
 Procedure utilise pour dfinir la constante Time. Le calcule s'effectue
 selon la formule  tc := 256 - (1000000 / frequence).
}
begin;
  Wr_dsp($40);                     { $40 = Dfinition de la Sample Rate    }
  Wr_dsp(tc);
end;

procedure test_Transmission;
begin;
   getmem(blk,3000);
   fillchar(blk^,3000,127);
   TailleBloc := 2000;
   Dern_sortie := true;
   Sampling_Rate := 211;
   Jouer_Block_Dsp(TailleBloc,blk,true,false);
   delay(100);
   freemem(blk,3000);
end;

procedure write_sbConfig;
{
 La procdure imprime la configuration qu'elle a rencontr sur l'cran.
 Elle est d'abord un exemple comment on peut utiliser une information.
}
begin;
  clrscr;
  if SbRegDetected then begin;
    writeln('Carte son ',wrt_dsp_adr_sb16,'h avec IRQ ',
    wrt_dsp_irq,' trouv.');
  end else begin;
    writeln('Aucune carte son compatible SoundBlaster dtecte !');
  end;
  if MixerDetected then begin;
    writeln('Mixer - Chip trouv');
    if SbVersMaj < 4 then
      writeln('La carte dtecte est',
			' une Soundblaster Pro ou compatible')
    else
      writeln('La carte dtecte est une',
      ' Soundblaster 16 ASP ou compatible');
  end else begin;
    writeln('La carte dtecte est une',
    ' Soundblaster ou compatible');
  end;
  writeln('Le numro de la version : ',SbVersStr);
end;

procedure Exit_Sb16;
{
 Cette procdure se fait appeller lorsque vous quittez le programme
 et ramne l'interruption masqu de la DMA  sa valeur intiale.
}
begin;
  setintvec($8+dsp_irq,oldint);         { Rtablir l'ancienne interruption}
  port[$21] := Port[$21] or irqmsk;     { et ramne la masque }
  port[dsp_adr+$c] := $d3;              {  son ancienne valeur    }
  Port[$20] := $20;
  Wr_dsp($D0);
end;

procedure Jouer_Sb16(Segm,Offs,dsize : word);
{
 Cette procdure fait jouer le bloc de la taille dsize adress par
 Segm:Offs. Il faut faire attention, que le contrleur DMA
 NE PEUT PAS tre efficace au-del d'une page ...
}
var li : word;
begin;
  port[$0A] := dma_ch+4;                { fermer canal DMA         }
  Port[$0c] := 0;                       { Adresse du tampon (blk)  }
  Port[$0B] := $49;                     { pour la  sortie son      }
  Port[dma_adr[dma_ch]] := Lo(offs);    { pour le contrleur DMA  }
  Port[dma_adr[dma_ch]] := Hi(offs);
  Port[dma_wc[dma_ch]] := Lo(dsize-1);  { Taille d'un bloc   }
  Port[dma_wc[dma_ch]] := Hi(dsize-1);  { vers le contrleur DMA}
  Port[dma_page[dma_ch]] := Segm;
  if sb16_outputLong <> dsize then begin;
    Wr_dsp($C6);                   { Commande DSP de 8-Bit sur DMA  }
    if stereo then                      { pour le dmarrage de SB16 ! }
      Wr_dsp($20)
    else
      Wr_dsp($00);
    Wr_dsp(Lo(dsize-1));           { Taille du bloc       }
    Wr_dsp(Hi(dsize-1));           { vers la DSP                    }
    sb16_outputLong := dsize;
  end else begin;
    Wr_dsp($45);                   { DMA continue SB16 8-Bit    }
  end;
  Port[$0A] := dma_ch;                  { librer canal DMA  }
end;

procedure Jouer_SbPro(Segm,Offs,dsize : word);
{
 Cette procdure fait jouer le bloc de la taille dsize adress par
 Segm:Offs. Il faut faire attention, que le contrleur DMA
 NE PEUT PAS tre efficace au-del d'une page ...

}
var li : word;
begin;
  port[$0A] := dma_ch+4;                { fermer canal DMA           }
  Port[$0c] := 0;                       { Adresse du tampon   (blk)  }
  Port[$0B] := $49;                     { pour l'mission du son     }
  Port[dma_adr[dma_ch]] := Lo(offs);    { vers le DMA-Controller          }
  Port[dma_adr[dma_ch]] := Hi(offs);
  Port[dma_wc[dma_ch]] := Lo(dsize-1);  { Taille du bloc (block-  }
  Port[dma_wc[dma_ch]] := Hi(dsize-1);  { groesse) vers le contrleur DMA }
  Port[dma_page[dma_ch]] := Segm;

  Wr_dsp($48);
  Wr_dsp(Lo(dsize-1));             { Taille du bloc vers      }
  Wr_dsp(Hi(dsize-1));             { la  DSP                    }
  Wr_dsp($91);
  Port[$0A] := dma_ch;                  { librer canal DMA       }
end;

procedure Jouer_Sb(Segm,Offs,dsize : word);
{
 Cette procdure excute le bloc adress par Segm:Offs
 de taille dsize. Il faut noter que le contrleur DMA ne peut PAS
 travailler en accdant aux pages...
}
var li : word;
begin;
  port[$0A] := dma_ch+4;                { Bloque le canal DMA }
  Port[$0c] := 0;                       { Adresse du tampon (blk)  }
  Port[$0B] := $48+dma_ch;              { Pour la sortie du son }
  Port[dma_adr[dma_ch]] := Lo(offs);    { au DMA-Controller }
  Port[dma_adr[dma_ch]] := Hi(offs);
  Port[dma_wc[dma_ch]] := Lo(dsize-1);  { Taille du bloc }
  Port[dma_wc[dma_ch]] := Hi(dsize-1);  { au DMA-Controller }
  Port[dma_page[dma_ch]] := Segm;
  Wr_dsp($14);
  Wr_dsp(Lo(dsize-1));                  { Taille du bloc }
  Wr_dsp(Hi(dsize-1));                  {  la DSP }
  Port[$0A] := dma_ch;                  { Libre le canal DMA }
end;

procedure Jouer_Block_Dsp(gr : word;bk : pointer;b1,b2 : boolean);
{
 La procdure dmarre la sortie du bloc de donnes blk de la taille
 TailleBloc via DMA
}
var l : longint;
    pn,offs : word;
    hbyte : byte;
    a : word;
    OldV,NewV,Aide : byte;
    stereoreg : byte;
    sr : word;
    samps : byte;
begin;
  Transfer_Testing := b1;

  dsp_rdy_sb16 := false;
  l := 16*longint(pt(bk).sgm)+pt(bk).ofs;
  pn := pt(l).sgm;
  offs := pt(l).ofs;

  if Transfer_Testing then begin;
    set_timeconst_sb16(Sampling_Rate);
    if sb16Detected then begin;
      if stereo then
        Jouer_Sb16(pn,offs,gr*2)
      else
        Jouer_Sb16(pn,offs,gr);
    end else begin;
      if stereo then begin;
        SR := word(-1000000 DIV (Sampling_Rate-256));
        SR := SR * 2;
        Samps := 256 - (1000000 DIV SR);
        set_timeconst_sb16(Samps);
        Jouer_SbPro(pn,offs,gr*2);
      end else
        Jouer_Sb(pn,offs,gr);
    end;
  end else begin;
    sb16_outputLong := 0;
    set_timeconst_sb16(vblock.SR);
    if sb16Detected then begin;
      if stereo then begin;
        Jouer_Sb16(pn,offs,gr);
      end else begin;
        Jouer_Sb16(pn,offs,gr);
      end;
    end else begin;
      if stereo then begin;
        Jouer_SbPro(pn,offs,gr);
      end else begin;
        Jouer_Sb(pn,offs,gr);
      end;
    end;
  end;
end;



procedure dsp_int_sb16; interrupt;
{
 On passe  cette procdure avec l'interruption gnre  la fin
 d'un transfert de bloc. Si le flag dern_sortie n'a pas t pos,
 une nouvelle sortie dmarre.
}
var h : byte;
begin;
  if interrupt_check then begin;
    IRQDetected := true;
  end else begin;
    if Transfer_Testing then begin;
      h := port[dsp_adr+$E];
      dsp_rdy_sb16 := true;

      if not dern_sortie then begin;
        Jouer_Block_Dsp(taillebloc,blk,true,false);
      end;
    end else begin;
      h := port[dsp_adr+$E];
      if (fgr > t_bloc) and not lastone then begin
        lastone := false;
        if bloc_actif = 1 then begin
          Jouer_Block_Dsp(t_bloc,blk2,false,true);
          blockread(vocf,blk1^,t_bloc);
          fgr := fgr - t_bloc;
          bloc_actif := 2;
        end else begin;
          Jouer_Block_Dsp(t_bloc,blk1,false,true);
          blockread(vocf,blk2^,t_bloc);
          fgr := fgr - t_bloc;
          bloc_actif := 1;
        end;
      end else begin;
        if not lastone then begin;
          if bloc_actif = 1 then begin
            Jouer_Block_Dsp(t_bloc,blk2,false,true);
            lastone := true;
          end else begin;
            Jouer_Block_Dsp(t_bloc,blk1,false,true);
            lastone := true;
          end;
        end else begin;
          dsp_rdy_sb16 := true;
          Wr_dsp($D0);
          VOC_READY := true;
        end;
      end;
    end;
  end;
  Port[$20] := $20;
end;

procedure detect_sbIRQ;
{
 Cette routine reconnat l'interruption de la carte Sound Blaster. Pour cela
 on teste toutes les interruptions possibles. On envoie des blocs courts
 via DMA. Si la sortie se conclut par le saut  l'interruption indique,
 celle-ci a t trouve.
}
const irqs_possibles : array[1..5] of byte = ($2,$3,$5,$7,$10);
var i : integer;
    h : byte;
begin;
 getintvec($8+dsp_irq,intback);         { Sauvegarde les valeurs ! }
 port21 := port[$21];
 getmem(blk,1200);
 fillchar(blk^,1200,127);
 set_Timeconst_sb16(211);
 Wr_dsp($D3);                           { Eteint le haut-parleur }
 i := 1;
 interrupt_check := true;
 while (i <= 5) and (not IRQDetected) do
   begin;
     dsp_irq := irqs_possibles[i];      { IRQ  tester }
     getintvec($8+dsp_irq,oldint);      { Interruption dtourne }
     setintvec($8+dsp_irq,@Dsp_Int_sb16);
     irqmsk := 1 shl dsp_irq;
     port[$21] := port[$21] and not irqmsk;
     Sampling_Rate := 211;
     tailleBloc := 1200;              { Sortie pour test }
     Jouer_Block_Dsp(tailleBloc,blk,true,false);
     delay(150);
     setintvec($8+dsp_irq,oldint);      { Rtablit l'interrupt }
     port[$21] := Port[$21] or irqmsk;
     h := port[dsp_adr+$E];
     Port[$20] := $20;
     inc(i);
   end;
 interrupt_check := false;
 Wr_dsp($D1);                           { Rtablit le haut-parleur }
 freemem(blk,1200);
 setintvec($8+dsp_irq,intback);         { Rtablit les valeurs !!!      }
 port[$21] := port21;
 dsp_rdy_sb16 := true;
end;

function Init_SB : boolean;
{
 Cette fonction initialise le Soundblaster. Elle renvoie TRUE,
 si l'initialisation a t russie, sinon FALSE.
 Le haut-parleur pour la sortie Sampling se fait activer. L'interruption
 DMA-Ready est masque
 }
begin;
  if not Detect_SBReg then begin;
    Init_SB := false;
    exit;
  end;
{ Soundblaster trouve      }
 if not force_irq then detect_sbIRQ;    { auto-dtection IRQ        }
   test_Transmission;
 if not force_irq then detect_sbIRQ;    { ncessit d'un 2me Test pour la SB  }
 if Detect_Mixer_sb16 then begin;
   SbProDetected := TRUE;               { SB Pro dtecte           }
 end;
 SbGetDspVersion;
 if SbVersMaj >= 4 then begin;          { SB 16 ASP dtecte         }
   Sb16Detected := true;
   SBProDetected := false;
 end;
 Wr_dsp($D1);                           { activer haut parleur       }
 getintvec($8+dsp_irq,oldint);          { sauvegarder ancienne interruption   }
 setintvec($8+dsp_irq,@dsp_int_sb16);   { positionner sur sa propre routine  }
 irqmsk := 1 shl dsp_irq;               { masquer interruption     }
 port[$21] := port[$21] and not irqmsk;
end;


{
 ***************************************************************************

                      P R O C E D U R E S   D E   M I X A G E

 ***************************************************************************
}


PROCEDURE Write_Mixer(Reg, Val: BYTE);
{
 Ecrit la valeur transfre dans Val dans le registre du Mixer-Chip
 indiqu par  Reg
}

begin;
 Port[dsp_adr+$4] := Reg;
 Port[dsp_adr+$5] := Val;
END;


FUNCTION Read_Mixer(Reg: BYTE) : BYTE;
{
 La fonction renvoie le contenu du registre du mixer-chip via  Reg
}
begin;
  Port[dsp_adr+$4] := Reg;
  Read_Mixer := Port[dsp_adr+$5];
end;

procedure Filter_On;
{
 La procdure contrle le filtre des basses, c'est  dire
 il procde au rglage des rgistres Bass/Treble correspondants
}
var Aide : byte;
begin;
 if sb16detected then begin;
   write_Mixer(68,64);                  { baisser Treble         }
   write_Mixer(69,64);
   write_Mixer(70,255);                 { basse Power maximal !          }
   write_Mixer(71,255);                 { basse Power maximal !          }
 end else begin;
   Aide := read_Mixer($0c);            { Filtre basse              }
   Aide := Aide or 8;
   Write_Mixer($0c,Aide);
   Aide := read_Mixer($0e);            { activer filtre         }
   Aide := Aide AND 2;
   write_Mixer($0e,Aide);
 end;
end;

procedure Filter_MID;
{
 C'est une procdure qui contrle le filtre des basses c'est  dire il
 contrle le rgistre Bass/Treble correspondant.
}
var Aide : byte;
begin;
 if sb16detected then begin;
   write_Mixer(68,160);                 { baisser Treble             }
   write_Mixer(69,160);
   write_Mixer(70,192);                 { basse Power maximal !     }
   write_Mixer(71,192);                 { basse Power maximal !     }
 end else begin;
   Aide := read_Mixer($0e);            { desactiver filtre         }
   Aide := Aide OR 32;
   write_Mixer($0e,Aide);
 end;
end;

procedure Filter_aus;
var Aide : byte;
begin;
 if sb16detected then begin;
   write_Mixer(68,192);                 { revenir aux valeurs par dfaut }
   write_Mixer(69,192);
   write_Mixer(70,160);
   write_Mixer(71,160);
 end else begin;
   Aide := read_Mixer($0c);            { filtre des hauteurs               }
   Aide := Aide OR 247;
   Write_Mixer($0c,Aide);
   Aide := read_Mixer($0e);            { active le filtre         }
   Aide := Aide AND 2;
   write_Mixer($0e,Aide);
 end;
end;

procedure Set_Balance(Valeur : byte);
{
 La procdure rgle la balance selon les valeurs transmises.
 0 indique la position toute  gauche, 12 correspond au milieu et 24 toute 
 droite.
 }
Var left,right : byte;
begin;
 if Sb16Detected then begin;
   left  := 12;
   right := 12;
   if Valeur < 12 then right := Valeur;
   if Valeur > 12 then left  := 24-Valeur;
   write_Mixer(50,(left  shl 4));
   write_Mixer(51,(right shl 4));
 end else begin;
  Valeur := Valeur SHR 1;
  case Valeur of
     0..6 : begin;
               write_Mixer(02,(7 shl 5)+(Valeur shl 1));
             end;
       07 : begin;
               write_Mixer(02,(7 shl 5)+(7 shl 1));
             end;
	  08..13 : begin;
               write_Mixer(02,((13-Valeur) shl 5)+(7 shl 1));
	           end;
	 end;
 end;
end;

procedure Set_Volume(Valeur : byte);
{
 Pour rgler le volume lors de l'coute. Les valeurs peuvent se situer entre 0 et 31
}
begin;
  if sb16detected then begin;
    write_Mixer(48,(Valeur shl 3));
    write_Mixer(49,(Valeur shl 3));
  end else begin;
    if MixerDetected then begin;
      Valeur := Valeur Shr 2;
      write_Mixer($22,(Valeur shl 5) + (Valeur shl 1));
    end;
  end;
end;

procedure reset_Mixer; assembler;
{
 Le Mixer Chip reoit de nouveau ses valeurs par dfaut
}
asm
  mov dx,dsp_adr+$4
  mov al,0
  out dx,al
  mov cx,50
@loop:
  loop @loop
  inc dx
  out dx,al
end;

FUNCTION Detect_Mixer_sb16 : BOOLEAN;
{
 Fonction qui permet l'identification du Mixer-Chips. Elle retourne TRUE, si un Mixer
 a t dtect, sinon FALSE
}
VAR SaveReg : WORD;
    NewReg  : WORD;
BEGIN
  Detect_Mixer_sb16 := MixerDetected;
  IF (NOT SbRegDetected)                { Quitter, s'il n'y a pas }
  OR MixerDetected THEN EXIT;           { de carte SOUNDBLASTER    }
                                        { ou s'il y avait dj une }
                                        { initalisation d'un Mixer-Chip }
  Reset_Mixer;
  SaveReg := Read_Mixer($22);           { Sauvegarde des registres  }
  Write_Mixer($22, 243);                { Si la valeur actuellement inscrite  }
  NewReg  := Read_Mixer($22);           { ne diffre pas de la valeur }
                                        { prcdente, l'accs s'avre  }
                                        { possible, c'est  dire,  }
                                        { un mixer existe        }
  IF NewReg = 243 THEN begin;
    MixerDetected := TRUE;
    STEREO := True;
  end;
  Write_Mixer($22, SaveReg);            { retour au registre prcdant  }
  Detect_Mixer_sb16 := MixerDetected;
END;


procedure exit_song;
begin;
 Port[dsp_adr+$C] := $D3;
 halt(0);
end;

{$F+}
procedure MODExitProc;
var mlj : byte;
 begin
 ExitProc := SaveExitProc;
 Exit_Sb16;
end;
{$F-}

{
  **************************************************************************
          Les     Routines  du    V O C  -  P l a y e r

    montrent l'excution d'un fichier VOC sans
    intgration d'un traitement spar des blocs.
  **************************************************************************
}




procedure Init_Voc(filename : string);
const VOCid : string = 'Creative Voice File'+#$1A;
var ch : char;
    idstr : string;
    ct : byte;
    h : byte;
    error : integer;
    srlo,srhi : byte;
    SR : word;
    Samplingr : word;
    stereoreg : byte;
begin;
  Transfer_Testing := false;
  VOC_READY   := false;
  vocsstereo := stereo;
  stereo := false;

  assign(vocf,filename);
  reset(vocf,1);
  if filesize(vocf) < 5000 then begin;
    VOC_READY   := true;
    exit;
  end;
  blockread(vocf,voch,$19);
  idstr := voch.Ident;
  if idstr <> VOCid then begin;
    { Identification fausse ! }
    VOC_READY   := true;
    exit;
  end;

  Blockread(vocf,inread,20);
  vblock.Ident_code := inread[2];

  if vblock.Ident_code = 1 then begin;
    vblock.SR := inread[6];
  end;

  if vblock.Ident_code = 8 then begin;
    SR := inread[6]+(inread[7]*256);
    Samplingr := 256000000 div (65536 - SR);
    if inread[9] = 1 then begin; {stereo}
      if sb16detected then samplingr := samplingr shr 1;
      stereo := true;
    end;
    vblock.SR := 256 - longint(1000000 DIV samplingr);
  end;

  if vblock.Ident_code = 9 then begin;
    Samplingr := inread[6]+(inread[7]*256);
    if inread[11] = 2 then begin; {stereo}
      stereo := true;
      if sbprodetected then samplingr := samplingr * 2;
      vblock.SR := 256 - longint(1000000 DIV (samplingr));
    end else begin;
      vblock.SR := 256 - longint(1000000 DIV samplingr);
    end;
  end;


  if vblock.SR < 130 then vblock.SR := 166;
  set_timeconst_sb16(vblock.SR);

  t_bloc := filesize(vocf) - 31;
  if t_bloc > 2500 then t_bloc := 2500;
  blockread(vocf,blk1^,t_bloc);

  ch := #0;
  fgr := filesize(vocf) - 32;
  fgr := fgr - t_bloc;
  Bloc_actif := 1;

  if fgr > 1 then begin;
    blockread(vocf,blk2^,t_bloc);
    fgr := fgr - t_bloc;
  end;

 Wr_dsp($D1);
 lastone := false;

 if not sb16Detected then begin;
   if Stereo then begin;
     stereoreg := Read_Mixer($0E);
     stereoreg := stereoreg OR 2;
     Write_Mixer($0E,stereoreg);
   end else begin;
     stereoreg := Read_Mixer($0E);
     stereoreg := stereoreg AND $FD;
     Write_Mixer($0E,stereoreg);
   end;
 end;

 Jouer_Block_Dsp(t_bloc,blk1,false,true);
end;

procedure voc_done;
var h : byte;
begin;
 lastone := true;
 repeat until dsp_rdy_sb16;
 close(vocf);
 Reset_SBCard;
 stereo := vocsstereo;
end;

begin;
 SaveExitProc := ExitProc;
 ExitProc := @MODExitProc;
 dsp_rdy_sb16 := true;
 getmem(blk1,2500);
 getmem(blk2,2500);
end.

